<script setup>
import { computed, ref } from "vue";
import { useStore } from "vuex";
import { chunk } from "lodash";
import FoldOut from "@components/Template/FoldOut.vue";

// Connect to Store and Router
const store = useStore();
const container = ref(null);

store
  .dispatch("live/getItems", {
    query: {
      "dashboard.favorite": true,
      _sort_by: "modified_at",
      _sort_direction: -1,
    },
  })
  .then(() =>
    store.dispatch("live/getItems", {
      query: {
        _limit: 50,
        _sort_by: "modified_at",
        _sort_direction: -1,
      },
    }),
  );

// Compute necessary Store values for Component
const game = computed(() => store.state.game.selected);
const isLive = computed(() => store.state.live.isLive);
const showLiveInfo = ref(true);

const itemStream = computed(() => store.state.live.items);
const itemFavChuncks = computed(() => {
  const favorites = itemStream.value.filter((item) => item?.dashboard?.favorite);
  return chunk(favorites, 2);
});

function openTab(e, tabName) {
  // hide everything
  const links = container.value.getElementsByClassName("tab-link");
  const tabs = container.value.getElementsByClassName("tab-content");
  Array.from(links).forEach((node) => node.classList.remove("is-active"));
  Array.from(tabs).forEach((node) => node.classList.add("is-hidden"));
  // show selection
  container.value.querySelector(tabName).classList.remove("is-hidden");
  e.currentTarget.classList.add("is-active");
  // ececute child on visible function
  if (!isLive.value && tabName === "#tab-favorites") {
    store.dispatch("live/getItems", {
      query: {
        "dashboard.favorite": true,
        _sort_by: "modified_at",
        _sort_direction: -1,
      },
    });
  } else if (!isLive.value && tabName === "#tab-latest") {
    store.dispatch("live/getItems", {
      query: {
        _limit: 50,
        _sort_by: "modified_at",
        _sort_direction: -1,
      },
    });
  }
}

function toggleFavorite(item) {
  const data = {
    dashboard: {
      favorite: item?.dashboard?.favorite ? false : true,
      hidden_properties: item?.dashboard?.hidden_properties,
    },
  };
  if (item.type == "plugin") {
    store
      .dispatch("plugins/editItem", {
        plugin: item.plugin,
        collection: item.collection,
        item: item._id,
        data,
      })
      .then(() => {
        if (!isLive.value)
          store.dispatch("live/getItems", {
            query: {
              _limit: 50,
              _sort_by: "modified_at",
              _sort_direction: -1,
            },
          });
      });
  } else if (item.type == "data") {
    store
      .dispatch("collections/editDocument", {
        collection: item.collection,
        id: item._id,
        data,
      })
      .then(() => {
        if (!isLive.value)
          store.dispatch("live/getItems", {
            query: {
              _limit: 50,
              _sort_by: "modified_at",
              _sort_direction: -1,
            },
          });
      });
  } else {
    console.error(`Dashboard: Unknown Item Type ${item.type}. Unable to set favorite.`);
  }
}
</script>
<template>
  <div ref="container" class="is-clipped-container is-flex is-flex-direction-column has-background-purple-5 px-2">
    <h1 class="title is-5">Dashboard {{ game }}</h1>
    <div class="tabs">
      <ul>
        <li class="tab-link dashboard" @click="openTab($event, '#tab-favorites')">
          <a>FAVORITES</a>
        </li>
        <li class="tab-link dashboard is-active" @click="openTab($event, '#tab-latest')">
          <a>LATEST</a>
        </li>
      </ul>
    </div>
    <div class="tab-container is-scroll-container">
      <div v-if="!isLive && showLiveInfo" class="notification is-warning is-light">
        <span>
          Switch to
          <a @click="$store.dispatch('live/setIsLive', true)">
            Live Mode
            <Icon class="is-small" :icon="'play-circle'" />
          </a>
          to continuously get the latest Item data!
        </span>
        <Icon class="is-pulled-right m-1" :icon="'x-circle'" @click="showLiveInfo = false" />
      </div>
      <div id="tab-favorites" class="tab-content dashboard is-hidden">
        <div v-for="(favChunk, index) in itemFavChuncks" :key="`itemrow_${index}`">
          <div class="tile is-ancestor mx-0">
            <div v-for="item in favChunk" :key="item._id" class="tile is-parent">
              <article class="tile is-child box">
                <nav class="level mb-2">
                  <div class="level-left">
                    <div class="level-item">
                      <p class="has-text-is-live has-text-weight-semibold">
                        {{ item?.name || item?._id }}
                      </p>
                    </div>
                  </div>
                  <div class="level-right">
                    <Icon
                      class="m-1"
                      :icon="'star'"
                      :fill="item?.dashboard?.favorite ? '#796ae5' : 'none'"
                      @click.stop="toggleFavorite(item)"
                    />
                  </div>
                </nav>
                <div class="content">
                  <p>
                    Latest Update
                    <strong>{{ item.modified_at }}</strong>
                  </p>
                  <p>{{ item }}</p>
                </div>
              </article>
            </div>
          </div>
        </div>
      </div>
      <div id="tab-latest" class="tab-content dashboard">
        <div v-for="item in itemStream" :key="item._id" class="has-background-white has-border m-2">
          <FoldOut>
            <template #header>
              <nav class="level p-1 is-interactive">
                <div class="level-left">
                  <div class="level-item">
                    <p class="has-text-is-live has-text-weight-semibold">
                      {{ item?.name || item?._id }}
                    </p>
                  </div>
                  <div class="level-item">
                    <p>Latest Update {{ item.modified_at }}</p>
                  </div>
                </div>
                <div class="level-right">
                  <Icon
                    class="m-1"
                    :icon="'star'"
                    :fill="item?.dashboard?.favorite ? '#796ae5' : 'none'"
                    @click.stop="toggleFavorite(item)"
                  />
                </div>
              </nav>
            </template>
            <template #default>
              <pre>{{ item }}</pre>
            </template>
          </FoldOut>
        </div>
      </div>
    </div>
  </div>
</template>
